/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <klocale.h>
#include <kapp.h>
#include <kpopupmenu.h>
#include <kiconloader.h>

#include "systemtray.h"


SystemTray::SystemTray( QWidget *parent, const char *name )
   : KSystemTray( parent, name )
{
   Par = parent;
   isFirstTime=TRUE;
}

SystemTray::~SystemTray()
{
}

void SystemTray::contextMenuAboutToShow( KPopupMenu* menu )
{
    if (isFirstTime) {
      Menu = menu;
      Menu->removeItemAt(3);
      Menu->removeItemAt(2);

      Menu->insertItem(SmallIcon("exit"), i18n("&Exit" ),kapp, SLOT(quit()) );
      Menu->insertSeparator();
      Menu->insertItem(SmallIcon("reload"),i18n("&About QTrans"),Par,SLOT(slot_About()));
      Menu->insertItem(SmallIcon("configure"), i18n("&Configure" ),Par, SLOT(slot_Config()) );
      Menu->insertSeparator();
      Menu->insertItem(i18n("&Show/Hide"),Par,SLOT(slot_ShortCut()));
      isFirstTime=FALSE;
    }
}
