/***************************************************************************
                          utils.cpp  -  description
                             -------------------
    begin                : Sun Dec 17 2000
    copyright            : (C) 2000 by Olaf3
    email                : merlim@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qmessagebox.h>
#include <kaboutdialog.h>
#include <kaboutdata.h>
#include <klocale.h>
//#include <kapp.h>
#include <stdlib.h>
#include <string>

#include "qtrans.h"
#include "utils.h"
#include "settings.h"

/*-- Configuration file parser --*/
int QTrans::Configure(QString CF_name)
{
  char c;
  enum {Null,Eng,Lang,AutoPop,Dock,dClose,startmin,enableshortKey,shortkey};
  unsigned int next=Null;

  QString home,path;
  home = getenv("HOME");
  path = home+'/'+CF_name;

  ifstream file;
  file.open(path, ios::in);
  if (!file) {
    cerr << i18n("Config file """) << path << i18n(""" not found.\n");
    QString cmd = "/bin/mkdir "+home+"/.qtrans";
    system(cmd);
    QString KdeDir = "/usr";//getenv("KDEDIR");
    cmd = "/bin/cp "+KdeDir+"/share/doc/qtrans-"+VERSION+"/default.conf "+home+"/"+CF_name;
    system(cmd);
    return(-1);
  }
  AutoPopUp=FALSE;
  enableShortCut=FALSE;
  DockIcon=FALSE;
  StartMin=FALSE;
  DontClose=FALSE;
  ShortKey="";
  QString look,temp;
  while ((c = file.get()) != EOF)
  {
    switch (c) {
      case '#' : do {} while ((file.get()!='\n')&&(file.get()!=EOF));break;
      case ' ' :
      case '\n': break;
      case ';' : if (next==Null) {cerr << i18n("Config file """)<<CF_name<<i18n(""" not valid!\n");
                              file.close(); return(-1);
                             }
                  if (next==Eng) {English_Path = look;next=Null; look = "";
                                  cout << "English Dic: " << English_Path << '\n';
                                 }
                  if (next==Lang) {Lang_Path = look;next=Null; look = "";
                                   cout << "Specific language Dic: " << Lang_Path << '\n';
                                  }
                  if (next==AutoPop) {if (look=="TRUE") AutoPopUp=TRUE;
                                      else AutoPopUp=FALSE;
                                      cout << "Auto PopUp: " << look << '\n';next=Null; look = "";
                                     }
                  if (next==Dock) {if (look=="TRUE") DockIcon=TRUE;
                                   else DockIcon=FALSE;
                                   cout << "Dock Icon: " << look << '\n';next=Null; look = "";
                                  }
                  if (next==dClose) {if (look=="TRUE") DontClose=TRUE;
                                   else DontClose=FALSE;
                                   cout << "Don't close window: " << look << '\n';next=Null; look = "";
                                  }
                  if (next==startmin) {if (look=="TRUE") StartMin=TRUE;
                                       else StartMin=FALSE;
                                       cout << "Start Minimized: " << look << '\n';next=Null; look = "";
                                      }
                  if (next==enableshortKey) {if (look=="TRUE") enableShortCut=TRUE;
                                            else enableShortCut=FALSE;
                                            cout <<"Enable ShortCut: "<<look<<'\n';next=Null;look="";
                                           }
                  if (next==shortkey) {ShortKey=look;
                                       if (enableShortCut){
                                         ShortCut = new KGlobalAccel();
                                         ShortCut->insertItem( i18n("Show/Hide"), "show/hide",ShortKey);
                                         ShortCut->connectItem( "show/hide",this, SLOT(slot_ShortCut()));
                                         ShortCut->readSettings();
                                       }
                                       cout <<"Short Keys: "<<look<<'\n';next=Null;look="";
                                      }
                  //next=Null; look = "";
                  break;

      default  : temp[0]=c;
                 look = look + temp;
                 if (look=="ENGDIC=") {next=Eng;look = "";}
                 if (look=="LANG=") {next=Lang;look = "";}
                 if (look=="AUTOPOPUP=") {next=AutoPop;look = "";}
                 if (look=="DOCKENABLED=") {next=Dock;look = "";}
                 if (look=="DONTCLOSE=") {next=dClose;look = "";}
                 if (look=="STARTMIN=") {next=startmin;look = "";}
                 if (look=="ENABLE_SHORT_CUT=") {next=enableshortKey;look="";}
                 if (look=="SHORT_KEY=") {next=shortkey;look="";}
                 //look = "";
    }
  }
  file.close();
  if ((English_Path=="")||(Lang_Path=="")) {cerr << i18n("Not enough parameters in config file!\n");
                                        return (-1);
                                       }
  return(0);
}

/*-- Convert from "string" to "QString" --*/
QString str(string s){
   int n=s.size();
   QString S;
   for (int i=0;i<n;i++) S[i]=s[i];
   return S;
}

/*-- Convert and add a space after ';' --*/
QString str_2(string s){
   QString S=str(s);
   int i=-1;
   do {
     i = S.find(';',i+1);
     if (i!=-1) S.insert(i+1," ");
   } while (i!=-1);
   return S;
}

/*-- Truncate a string at the first space char --*/
QString tr_str(QString s) {
   QString S = s.simplifyWhiteSpace();
   int i = S.find(' ',0);
   if (i>0) S.truncate(i);
   return S;
}
